unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, xmldom, XMLIntf, msxmldom, XMLDoc, StdCtrls, ExtCtrls,
  ComCtrls,math;

type
PNota=^Tnota;
TNota=record
        pauza:boolean;
        delka:real;
        vyska:string;
        x,y:integer;
end;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Nast1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Image1: TImage;
    TrackBar1: TTrackBar;
    Ulo6it1: TMenuItem;
    Uloitjako1: TMenuItem;
    Button2: TButton;
    GroupBox1: TGroupBox;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    Button3: TButton;
    ComboBox1: TComboBox;
    CheckBox2: TCheckBox;
    GroupBox2: TGroupBox;
    RadioGroup2: TRadioGroup;
    Button4: TButton;
    SaveDialog1: TSaveDialog;
    Edit1: TEdit;
    Button5: TButton;
    kONEC1: TMenuItem;
    procedure Nast1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Ulo6it1Click(Sender: TObject);
    procedure Uloitjako1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button5Click(Sender: TObject);
    procedure kONEC1Click(Sender: TObject);
  private
    function Nacti(filename:string):boolean;
    procedure Uloz(filename:string);
    procedure Kresli;
    procedure KresliNotu(var x:integer;nota: Pnota);
    function NajdiNotu(x,y:integer):integer;
    procedure Repaint;
  private
    Takt:array [0..1] of integer;
    Select:integer;
    Savefilename:string;

    Takty:array[0..3] of TBitmap;
    Noty1:array [0..3] of TBitmap;
    Noty2:array [0..3] of TBitmap;
    Noty1k:array [0..3] of TBitmap;
    Noty2k:array [0..3] of TBitmap;
    klic:TBitmap;
    pomlky:array [0..3] of TBitmap;
    Buf:TBitmap;
  end;

var
  Form1: TForm1;
  Noty:TList;
  posVTaktu: single;

implementation

{$R *.dfm}

function TForm1.Nacti(filename: string):boolean;
var f:TFileStream;

function readTag(S:TStream):string;
var pos:integer;
     ch:char;
     res:string;
begin
 res:='';
 s.read(ch,1);
 while (ch<>'<') do
  begin
   f.read(ch,1);
   if s.Position=S.Size then
    begin
    Result:='';
    exit;
    end;
  end;
 f.read(ch,1);
 while ch<>'>' do
  begin
   if s.Position=S.Size then
    begin
    Result:='';
    exit;
    end;
   res:=res+ch;
   f.read(ch,1);
  end;
 Result:=Res;
end;

var s,d:string;
    nota:PNota;
    i,o,m,n:integer;

begin
 result:=false;
 Noty.Clear;
  f:=TFileStream.Create(filename,fmopenread);
  s:=readtag(f);
  if not TryStrToInt(s[pos('"',s)+1],takt[0]) then exit;
  if not TryStrToInt(s[pos('"',s)+3],takt[1]) then exit;
  if takt[1]<>4 then exit;

 s:=readtag(f);
 while (s<>'/skladba') and (s<>'') do
  begin
   nota:=new(Pnota);
   if pos('delka',s)=0 then exit;

   i:=0;
   while s[i]<>'"' do inc(i);
   o:=i+1;
   while s[o]<>'"' do inc(o);

   d:= copy(s,i+1,o-i-1);
   if pos('.',d)<>0 then d[pos('.',d)]:=',';
   nota.delka:=StrToFloat(d);

   if pos ('pomlka',s)<>0 then
    begin
     nota.pauza:=true;
     nota.vyska:='0';
    end else
    begin
   nota.pauza:=false;
   i:=o+1;
   while s[i]<>'"' do inc(i);
   o:=i+1;
   while s[o]<>'"' do inc(o);
   nota.vyska:=copy(s,i+1,o-i-1);
  end;

   Noty.Add(nota);
   s:=readtag(f);
  end;

 Buf.Width:=Noty.Count*100+500;
 TrackBar1.Max:=Buf.Width-Image1.Width;
 Buf.Height:=Image1.Height;
 Kresli;
 f.Free;
 result:=true;
end;

procedure TForm1.Nast1Click(Sender: TObject);
begin
 if OpenDialog1.Execute then
  begin
  if not
   Nacti(OpenDialog1.FileName) then ShowMessage('Chyba') else
   Savefilename:=OpenDialog1.FileName;
  end;
end;

procedure TForm1.Uloz(filename: string);
var f:TFileStream;
    s:string;
    i:integer;
    pom:PNota;
begin
 f:=TFileStream.Create(filename,fmCreate);
 s:='<skladba takt="'+inttostr(takt[0])+'/4">'+#10#13;
 f.Write(PANSICHAR(s)^,length(s));

 for i:=0 to noty.count-1 do
  begin
   pom:=Noty.Items[i];
   if pom.pauza then
   begin
    s:='<pomlka delka="'+floattostr(pom.delka)+'"/>'+#10#13;
    f.Write(PANSICHAR(s)^,length(s));
   end else
   begin
    s:='<nota delka="'+floattostr(pom.delka)+'" vyska="'+pom.vyska+'"/>'+#10#13;
    f.Write(PANSICHAR(s)^,length(s));
   end;
  end;
 s:='</skladba>';
 f.Write(PANSICHAR(s)^,length(s));

 f.Free;
 ShowMessage('Uloeno.');
end;

procedure TForm1.FormCreate(Sender: TObject);
var all:TBitmap;
    i:integer;

procedure CopyBmp(b1,b2:TBitmap;x,y,w,h:integer);
begin
 b2.Width:=w;
 b2.Height:=h;
 b2.Canvas.Draw(-x,-y,b1);
end;

begin
if not FileExists('all.bmp') then
ShowMessage('Nelze najt all.bmp');
all:=TBitmap.Create;
all.LoadFromFile('all.bmp');

select:=-1;
noty:=TList.Create;
Buf:=TBitmap.Create;
Buf.Width:=Image1.Width;
Buf.Height:=Image1.Height;

for i:=0 to 3 do
 begin
 Noty1[i]:=TBitmap.Create;
 Noty2[i]:=TBitmap.Create;
 Noty1k[i]:=TBitmap.Create;
 Noty2k[i]:=TBitmap.Create;
 pomlky[i]:=TBitmap.Create;
 end;
for i:=0 to 2 do
  takty[i]:=TBitmap.Create;
klic:=TBitmap.Create;

for i:=0 to 3 do
 CopyBmp(all,noty1[i],140+i*20,60,20,60);
for i:=0 to 3 do
 CopyBmp(all,noty1k[i],230+i*25,60,26,60);
for i:=0 to 3 do
 CopyBmp(all,noty2[i],340+i*20,60,20,60);
for i:=0 to 3 do
 CopyBmp(all,noty2k[i],425+i*25,60,26,60);
for i:=0 to 3 do
 CopyBmp(all,pomlky[i],530+i*20,60,20,60);
for i:=0 to 2 do
 CopyBmp(all,takty[i],35+i*38,60,22,60);

 CopyBmp(all,klic,0,60,25,60);
end;

procedure TForm1.Kresli;
var i:integer;
    pos:integer;
    p:PNota;
begin
Buf.Canvas.Rectangle(0,0,Buf.Width,buf.Height);

Buf.Canvas.Draw(10,35,klic);
Buf.Canvas.Draw(50,35,takty[takt[0]-3]);


pos:=80;
posVTaktu:=0;

for i:=0 to Noty.Count-1 do
 begin
  KresliNotu(pos,Noty.Items[i]);
 end;

for i:=0 to 4 do
begin
buf.Canvas.MoveTo(0,50+i*10);
buf.Canvas.lineTo(Buf.Width,50+i*10);
end;

 TrackBar1.Max:=pos-Image1.Width;
 Image1.Canvas.Draw(0,0,buf);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 Image1.Canvas.Draw(-TrackBar1.Position,0,buf);
 Repaint;
end;

function StrToNota(nazev:string):integer;
begin
 if (nazev='C') or (nazev='Cis') then begin result:=0; exit; end;
 if (nazev='D') or (nazev='Dis') then begin result:=5; exit; end;
 if (nazev='E') then begin result:=10; exit; end;
 if (nazev='F') or (nazev='Fis') then begin result:=15; exit; end;
 if (nazev='G') or (nazev='Gis') then begin result:=20; exit; end;
 if (nazev='A') or (nazev='Ais') then begin result:=20; exit; end;
 if (nazev='H') then begin result:=30; exit; end;
 if (nazev='c') or (nazev='cis') then begin result:=35; exit; end;
 if (nazev='d') or (nazev='dis') then begin result:=40; exit; end;
 if (nazev='e') then begin result:=45; exit; end;
 if (nazev='f') or (nazev='fis') then begin result:=50; exit; end;
 if (nazev='g') or (nazev='gis') then begin result:=55; exit; end;
 if (nazev='a') or (nazev='ais') then begin result:=60; exit; end;
 if (nazev='h') then begin result:=65; exit; end;
 result:=0;
end;

function getIndex(delka:real):integer;
begin
 if delka=0.5 then result:=0 else
 if delka=1 then result:=1 else
 if delka=1.5 then result:=1 else
 if delka=2 then result:=2 else
 if delka=3 then result:=2 else
 if delka=4 then result:=3 else
 result:=0;
end;


procedure TForm1.KresliNotu(var x:integer; nota: Pnota);
var s:string;
    p:integer;
    len:real;
    pom:TNota;
    count,start:integer;
    points:array [0..3] of TPoint;
begin
 pom:=nota^;
 s:=nota.vyska;
 p:=StrToNota(s);


nota.x:=x+4+round(2*pom.delka);
nota.y:=100-p;

len:=min(pom.delka,(takt[0]-posVTaktu));
if len=2.5 then len:=2;
if len>4 then len:=4;
count:=0;
start:=x;

while len>0 do
begin
 inc(count);

 x:=x+8+round(2*pom.delka);
 if pom.pauza then
 begin
  Buf.Canvas.Draw(x,32,pomlky[getINdex(len)]);
  p:=30;
 end else
 begin
 if p<30 then
 begin
 if length(s)>1 then
 Buf.Canvas.Draw(x,60-p,noty1k[getINdex(len)]) else
 Buf.Canvas.Draw(x,60-p,noty1[getINdex(len)]);
 end else
 begin
 if length(s)>1 then
 Buf.Canvas.Draw(x,60-p,noty2k[getINdex(len)]) else
 Buf.Canvas.Draw(x,60-p,noty2[getINdex(len)]);
 end;
 end;


 if (len=3)or (len=1.5)   then
 begin
  Buf.Canvas.Brush.Color:=clblack;
  Buf.Canvas.Ellipse(x+20,102-p,x+25,98-p);
  Buf.Canvas.Brush.Color:=clwhite;
 end;

 if not pom.pauza
 then begin
 if p<5 then
  begin
   Buf.Canvas.MoveTo(x+0,60-p+40);
   Buf.Canvas.LineTo(x+15,60-p+40);
  end;
 end;

 x:=x+15+round(10*pom.delka);
 pom.delka:=pom.delka-len;
 posVTaktu:=posVTaktu+len;

 if posVTaktu=Takt[0] then
 begin
   posVTaktu:=0;
   x:=x+20;
   Buf.Canvas.MoveTo(x,50);
   Buf.Canvas.LineTo(x,90);
   x:=x+20;
 end;

 len:=min(pom.delka,(takt[0]-posVTaktu));
 if len=2.5 then len:=2;
 if len>4 then len:=4;
end;

if(count >1)and (not pom.pauza) then
 begin

 if p>=30 then
 begin
   points[0]:=Point(start+10,80-p);
   points[1]:=Point(start+15,65-p);
   points[2]:=Point(x-15,65-p);
   points[3]:=Point(x-10,80-p);
 end else
  begin
   points[0]:=Point(start+10,110-p);
   points[1]:=Point(start+15,125-p);
   points[2]:=Point(x-15,125-p);
   points[3]:=Point(x-10,110-p);
  end;

   Buf.Canvas.PolyBezier(points);
 end;

end;

function TForm1.NajdiNotu(x, y: integer): integer;
var i:integer;
begin
i:=0;
while (i<Noty.Count-1)and (PNOTA(Noty.Items[i]).x<x) do inc(i);
Result:=i;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if noty.Count>0 then
  select:=NajdiNotu(x+TrackBar1.Position,y);
end;



procedure TForm1.Button3Click(Sender: TObject);
var p:PNota;
begin
 If Select<>-1 then
  begin
   p:=new(pNota);
   p.pauza:=false;
  case RadioGroup1.ItemIndex of
  0:p.delka:=0.5;
  1:p.delka:=1;
  2:p.delka:=2;
  3:p.delka:=4;
  end;
   if CheckBox1.Checked then p.delka:=p.delka*1.5;
   if CheckBox2.Checked then p.pauza:=true;
   p.vyska:=ComboBox1.Items[ComboBox1.itemindex];
   Noty.Insert(select,p);
   Kresli;
   Repaint;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 If Select<>-1 then
  begin
   Noty.Delete(Select);
   Kresli;
   Repaint;
  end;
end;

procedure TForm1.Repaint;
var n:PNota;
begin
 Image1.Canvas.Draw(-TrackBar1.Position,0,buf);
 if select<>-1 then
 begin
  n:=Noty.Items[select];
  Image1.Canvas.moveTo(n.x-TrackBar1.Position-5,0);
  Image1.Canvas.LineTo(n.x-TrackBar1.Position-5,200);
 end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
case RadioGroup2.ItemIndex of
 0:takt[0]:=3;
 1:takt[0]:=4;
 2:takt[0]:=5;
end;
 Kresli;
 Repaint;
end;

procedure TForm1.Ulo6it1Click(Sender: TObject);
begin
if savefilename<>''then
 Uloz(savefilename);
end;

procedure TForm1.Uloitjako1Click(Sender: TObject);
begin
 if SaveDialog1.Execute then
begin
 Savefilename:=SaveDialog1.FileName;
 Uloz(Savefilename);
end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 Repaint;
end;

function StrToNotaINt(nazev:string):integer;
begin
 if (nazev='C') then begin result:=1; exit; end;
 if (nazev='Cis') then begin result:=2; exit; end;
 if (nazev='D') then begin result:=3; exit; end;
 if (nazev='Dis') then begin result:=4; exit; end;
 if (nazev='E') then begin result:=5; exit; end;
 if (nazev='F') then begin result:=6; exit; end;
 if (nazev='Fis') then begin result:=7; exit; end;
 if (nazev='G') then begin result:=8; exit; end;
 if (nazev='Gis') then begin result:=9; exit; end;
 if (nazev='A') then begin result:=10; exit; end;
 if (nazev='Ais') then begin result:=11; exit; end;
 if (nazev='H') then begin result:=12; exit; end;
 if (nazev='c') then begin result:=13; exit; end;
 if (nazev='cis') then begin result:=14; exit; end;
 if (nazev='d') then begin result:=15; exit; end;
 if (nazev='dis') then begin result:=16; exit; end;
 if (nazev='e') then begin result:=17; exit; end;
 if (nazev='f') then begin result:=18; exit; end;
 if (nazev='fis') then begin result:=19; exit; end;
 if (nazev='g') then begin result:=20; exit; end;
 if (nazev='gis') then begin result:=21; exit; end;
 if (nazev='a') then begin result:=22; exit; end;
 if (nazev='ais') then begin result:=23; exit; end;
 if (nazev='h') then begin result:=24; exit; end;
end;

function IntToNotaStr(l:integer):string;
begin
case l of
0:result:='C';
1:result:='Cis';
2:result:='D';
3:result:='Dis';
4:result:='E';
5:result:='F';
6:result:='Fis';
7:result:='G';
8:result:='Gis';
9:result:='A';
10:result:='Ais';
11:result:='H';
12:result:='c';
13:result:='cis';
14:result:='d';
15:result:='dis';
16:result:='e';
17:result:='f';
18:result:='fis';
19:result:='g';
20:result:='gis';
21:result:='a';
22:result:='ais';
23:result:='h';
end;

end;

procedure TForm1.Button5Click(Sender: TObject);
var pocet:integer;
    i:integer;
    p:PNota;
    l:Integer;
begin
pocet:=StrToInt(Edit1.Text);

for i:=0 to Noty.Count-1 do
 begin
  p:=Noty.Items[i];
  l:=StrToNotaINt(P.vyska)-1;
  l:=l+pocet;
  IF L>23 THEN L:=23;
  IF L<0 THEN L:=0;
  p.vyska:=IntToNotaStr(l);
 end;
 kresli;
 repaint; 
end;

procedure TForm1.kONEC1Click(Sender: TObject);
begin
 Close
end;

end.
